<script lang="ts">
  import { onMount } from 'svelte';
  import { eventId } from '@stores';
  import { Gql } from '@db';
  import type { Scores } from '@models/ScoreChart';
  import LeaderBoardData from '@components/Leaderboard/LeaderBoardData.svelte';

  export let shortNames: boolean;
  export let showService: boolean = true;
  export let showCtf: boolean = true;
  export let showBonus: boolean = true;
  export let visibleTeams: Record<string, boolean> = {};

  let scores: Scores[];
  $: updateVisibleTeams(visibleTeams);

  const LeaderBoardQuery = `
    LeaderBoard($eventId: uuid!) {
      scoreboard_team_summary(
        order_by: {score: {total: desc}},
        where: {event_id: {_eq: $eventId}}
      ) {
        score {
          bonus
          ctf
          event_id
          service
          team_id
          total
          team {
            id
            name
            long_name
          }
          bonus_by_category {
            category
            score
          }
        }
      }
    }`;

  onMount(async () => {
    // todo handle auth change
    Gql.subscribeSimple<{ scoreboard_team_summary: { score: Scores }[] }>(
      `subscription ${LeaderBoardQuery}`,
      (data) => {
        scores = filterVisibleTeams(data.scoreboard_team_summary.map((x) => x.score));
        console.log(scores);
      },
      { variables: { eventId: $eventId } },
    );
  });

  /**
   * Filter out teams that are not visible
   */
  function filterVisibleTeams(input: Scores[]): Scores[] {
    // @ts-ignore it could be undefined, but it's not!
    // filter out teams that are not visible
    return input.filter((e) => !(e.team.id in visibleTeams) || visibleTeams[e.team.id]);
  }

  function updateVisibleTeams(visibleTeams: Record<string, boolean>) {
    console.log('update vis teams', visibleTeams);
    if (!scores) return;
    scores = filterVisibleTeams(scores);
  }
  // todo find a way to trigger the blur effect _only when a team's position changes_, not when the team's score changes
</script>

{#if !scores}
  <p>Loading</p>
{:else}
  <div class="container-fluid text-center">
    <div class="header row my-2 py-2">
      <div class="col-1">
        <b>Rank</b>
      </div>
      <div class="col text-start">
        <b>Team</b>
      </div>
      {#if showService}
        <div class="col">
          <b>Service</b>
        </div>
      {/if}
      {#if showCtf}
        <div class="col">
          <b>CTF</b>
        </div>
      {/if}
      {#if showBonus}
        <div class="col">
          <b>Bonus</b>
        </div>
      {/if}
      <div class="col text-end">
        <b>Score</b>
      </div>
    </div>
    {#each scores as entry, rank}
      {#key entry.total}
        <div class="row my-2 py-2">
          <div class="col-1">
            <LeaderBoardData>{rank + 1}</LeaderBoardData>
          </div>
          <div class="col text-start">
            <LeaderBoardData>
              <b>
                {#if shortNames}
                  {entry.team.name}
                {:else}
                  {entry.team.long_name}
                {/if}
              </b>
            </LeaderBoardData>
          </div>
          {#if showService}
            <div class="col">
              <LeaderBoardData>
                {Math.floor(entry.service)}
              </LeaderBoardData>
            </div>
          {/if}
          {#if showCtf}
            <div class="col">
              <LeaderBoardData>
                {Math.floor(entry.ctf)}
              </LeaderBoardData>
            </div>
          {/if}
          {#if showBonus}
            <div class="col">
              <LeaderBoardData>
                {Math.floor(entry.bonus)}
              </LeaderBoardData>
            </div>
          {/if}
          <div class="col text-end">
            <LeaderBoardData>
              <b>{Math.floor(entry.total)}</b>
            </LeaderBoardData>
          </div>
        </div>
      {/key}
    {/each}
  </div>
{/if}

<style>
  .header {
    font-size: 1.1rem;
  }

  .row {
    border-style: solid;
    border-color: gray;
  }
</style>
